//----------------------------------------------------------------------------
// Copyright (c) 1997, 1998 by Joseph Parrello. All Rights Reserved.
// Site   : http://space.tin.it/computer/giparrel
// E-Mail : joparrel@tin.it, giusparr@tin.it, giparre@tin.it
//
// Revision:   1.0  (January 2,1998).
//
// Definition of JPControlGadget class.
//
// Read JPCONTGA.TXT for use and license.
//
// Only for OWL 5.02 users.
// OWL and ObjectWindows are trademarks of Borland International.
//
// THIS CLASS AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
// PARTICULAR PURPOSE.
//----------------------------------------------------------------------------
#include <owl/pch.h>

#include "jpcontga.h"


//{{JPControlGadget Implementation}}


JPControlGadget::JPControlGadget(TWindow& control, TBorderStyle borderstyle)
:
    TControlGadget(control, borderstyle)
{
  // INSERT>> Your constructor code here.
   IsCursorInControl = NULL;
}


JPControlGadget::~JPControlGadget()
{
  // INSERT>> Your destructor code here.

}


bool JPControlGadget::IdleAction(long idleCount)
{
  if (idleCount == 0)
  	{
  	TPoint crsPoint;
  	Window->GetCursorPos(crsPoint);
   HWND hwnd = Window->WindowFromPoint(crsPoint);
   if (hwnd)
   	{
      if (hwnd!=Control->GetHandle())
        {
        if (Window->GetHintMode() == TGadgetWindow::EnterHints)
            {
            if (IsCursorInControl)
               Window->SetHintCommand(-1);
            IsCursorInControl = false;
            }
        }
      else
        {
        if (Window->GetHintMode() == TGadgetWindow::EnterHints)
            {
            if (!IsCursorInControl)
               Window->SetHintCommand(Control->GetId());
            IsCursorInControl = true;
            }
        }
      }
   }
  return false;
}


void JPControlGadget::Created()
{
  TControlGadget::Created();

  // INSERT>> Your code here.
  if (Control->GetHandle())
      {
      string text = LoadInternalString(GetId());
      if (text.length())
         {
         TTooltip* tooltip = Window->GetTooltip();
         if (tooltip && tooltip->GetHandle())
            {
            TToolInfo toolInfo((HWND) Window->GetHandle(), (HWND) Control->GetHandle());
            if (tooltip->GetToolInfo(toolInfo))
              {
              #if defined(BI_PLAT_WIN32)
              toolInfo.SetText(text.c_str(), false);
              #elif defined(BI_PLAT_WIN16)
              toolInfo.SetText(text.c_str(), true);
              #endif
              tooltip->SetToolInfo(toolInfo);
              }
            }
         }
      }
}

string JPControlGadget::LoadInternalString(uint menuItemId)
{
	char szBuf[255];

   strcpy(szBuf,"");
   TWindow* parent= Window->GetParentO();
   TDecoratedFrame* frame= parent ?
                           TYPESAFE_DOWNCAST(parent, TDecoratedFrame) : 0;
   while (parent && !frame)
   {
     parent = parent->GetParentO();
     if (parent)
       frame = TYPESAFE_DOWNCAST(parent, TDecoratedFrame);
   }
   if (frame)
		frame->GetHintText(menuItemId, szBuf, sizeof(szBuf), htTooltip);
   return string(szBuf);
}

